#include <stdio.h>
#include <unistd.h>

int main(int argc, char *argv[])
{
	unsigned char buf[6];
	int s[4], parity, i;

	if (read(0, buf, sizeof(buf)) != sizeof(buf)) {
		printf("short read!\n");
		return 1;
	}

	s[0] = ((buf[5] & 0003) << 8) | ((buf[4] & 0377) >> 0);
	s[1] = ((buf[2] & 0017) << 6) | ((buf[5] & 0374) >> 2);
	s[2] = ((buf[3] & 0077) << 4) | ((buf[2] & 0360) >> 4);
	s[3] = ((buf[0] & 0377) << 2) | ((buf[3] & 0300) >> 6);
	parity = buf[1];

	for (i=0; i < 4; i++)
		printf("s[%d] = %d\n", i+1, s[i]);
	printf("parity = %d\n", parity);
	return 0;
}
